summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--Makefile23
-rwxr-xr-xconfigure12
-rw-r--r--hw/9pfs/9p.c2
-rw-r--r--hw/9pfs/9p.h8
-rwxr-xr-xscripts/git-submodule.sh72
5 files changed, 91 insertions, 26 deletions
diff --git a/Makefile b/Makefile
index ec73acfa9a..0496c5057a 100644
--- a/Makefile
+++ b/Makefile
@@ -18,17 +18,26 @@ git-submodule-update:
.PHONY: git-submodule-update
-ifeq (0,$(MAKELEVEL))
- git_module_status := $(shell \
- cd '$(SRC_PATH)' && \
- ./scripts/git-submodule.sh status $(GIT_SUBMODULES); \
- echo $$?; \
- )
+git_module_status := $(shell \
+ cd '$(SRC_PATH)' && \
+ GIT="$(GIT)" ./scripts/git-submodule.sh status $(GIT_SUBMODULES); \
+ echo $$?; \
+)
ifeq (1,$(git_module_status))
+ifeq (no,$(GIT_UPDATE))
git-submodule-update:
$(call quiet-command, \
- (cd $(SRC_PATH) && ./scripts/git-submodule.sh update $(GIT_SUBMODULES)), \
+ echo && \
+ echo "GIT submodule checkout is out of date. Please run" && \
+ echo " scripts/git-submodule.sh update $(GIT_SUBMODULES)" && \
+ echo "from the source directory checkout $(SRC_PATH)" && \
+ echo && \
+ exit 1)
+else
+git-submodule-update:
+ $(call quiet-command, \
+ (cd $(SRC_PATH) && GIT="$(GIT)" ./scripts/git-submodule.sh update $(GIT_SUBMODULES)), \
"GIT","$(GIT_SUBMODULES)")
endif
endif
diff --git a/configure b/configure
index e31d6a7fee..a6055c0710 100755
--- a/configure
+++ b/configure
@@ -267,10 +267,13 @@ stack_protector=""
if test -e "$source_path/.git"
then
+ git_update=yes
git_submodules="ui/keycodemapdb"
else
+ git_update=no
git_submodules=""
fi
+git="git"
# Don't accept a target_list environment variable.
unset target_list
@@ -1303,6 +1306,12 @@ for opt do
;;
--enable-capstone=system) capstone="system"
;;
+ --with-git=*) git="$optarg"
+ ;;
+ --enable-git-update) git_update=yes
+ ;;
+ --disable-git-update) git_update=no
+ ;;
*)
echo "ERROR: unknown option $opt"
echo "Try '$0 --help' for more information"
@@ -5413,6 +5422,7 @@ echo "local state directory queried at runtime"
echo "Windows SDK $win_sdk"
fi
echo "Source path $source_path"
+echo "GIT binary $git"
echo "GIT submodules $git_submodules"
echo "C compiler $cc"
echo "Host C compiler $host_cc"
@@ -5604,7 +5614,9 @@ echo "extra_cxxflags=$EXTRA_CXXFLAGS" >> $config_host_mak
echo "extra_ldflags=$EXTRA_LDFLAGS" >> $config_host_mak
echo "qemu_localedir=$qemu_localedir" >> $config_host_mak
echo "libs_softmmu=$libs_softmmu" >> $config_host_mak
+echo "GIT=$git" >> $config_host_mak
echo "GIT_SUBMODULES=$git_submodules" >> $config_host_mak
+echo "GIT_UPDATE=$git_update" >> $config_host_mak
echo "ARCH=$ARCH" >> $config_host_mak
diff --git a/hw/9pfs/9p.c b/hw/9pfs/9p.c
index f8bbac251d..52d46632fe 100644
--- a/hw/9pfs/9p.c
+++ b/hw/9pfs/9p.c
@@ -512,7 +512,7 @@ static int coroutine_fn v9fs_mark_fids_unreclaim(V9fsPDU *pdu, V9fsPath *path)
/* reopen the file/dir if already closed */
err = v9fs_reopen_fid(pdu, fidp);
if (err < 0) {
- return -1;
+ return err;
}
/*
* Go back to head of fid list because
diff --git a/hw/9pfs/9p.h b/hw/9pfs/9p.h
index d1cfeaf10e..cdfc4f4ce7 100644
--- a/hw/9pfs/9p.h
+++ b/hw/9pfs/9p.h
@@ -117,7 +117,7 @@ static inline char *rpath(FsContext *ctx, const char *path)
#define P9_IOHDRSZ 24
typedef struct V9fsPDU V9fsPDU;
-struct V9fsState;
+typedef struct V9fsState V9fsState;
typedef struct {
uint32_t size_le;
@@ -137,7 +137,7 @@ struct V9fsPDU
uint8_t id;
uint8_t cancelled;
CoQueue complete;
- struct V9fsState *s;
+ V9fsState *s;
QLIST_ENTRY(V9fsPDU) next;
uint32_t idx;
};
@@ -230,7 +230,7 @@ struct V9fsFidState
V9fsFidState *rclm_lst;
};
-typedef struct V9fsState
+struct V9fsState
{
QLIST_HEAD(, V9fsPDU) free_list;
QLIST_HEAD(, V9fsPDU) active_list;
@@ -251,7 +251,7 @@ typedef struct V9fsState
Error *migration_blocker;
V9fsConf fsconf;
V9fsQID root_qid;
-} V9fsState;
+};
/* 9p2000.L open flags */
#define P9_DOTL_RDONLY 00000000
diff --git a/scripts/git-submodule.sh b/scripts/git-submodule.sh
index 08932a35f0..030617b4ac 100755
--- a/scripts/git-submodule.sh
+++ b/scripts/git-submodule.sh
@@ -3,21 +3,49 @@
# This code is licensed under the GPL version 2 or later. See
# the COPYING file in the top-level directory.
-set -e
-
substat=".git-submodule-status"
command=$1
shift
-modules="$@"
+maybe_modules="$@"
-if test -z "$modules"
-then
- test -e $substat || touch $substat
- exit 0
-fi
+test -z "$GIT" && GIT=git
+
+error() {
+ echo "$0: $*"
+ echo
+ echo "Unable to automatically checkout GIT submodules '$modules'."
+ echo "If you require use of an alternative GIT binary (for example to"
+ echo "enable use of a transparent proxy), then please specify it by"
+ echo "running configure by with the '--with-git' argument. e.g."
+ echo
+ echo " $ ./configure --with-git='tsocks git'"
+ echo
+ echo "Alternatively you may disable automatic GIT submodule checkout"
+ echo "with:"
+ echo
+ echo " $ ./configure --disable-git-update'"
+ echo
+ echo "and then manually update submodules prior to running make, with:"
+ echo
+ echo " $ scripts/git-sbumodule.sh update $modules"
+ echo
+ exit 1
+}
-if ! test -e ".git"
+modules=""
+for m in $maybe_modules
+do
+ $GIT submodule status $m 1> /dev/null 2>&1
+ if test $? = 0
+ then
+ modules="$modules $m"
+ else
+ echo "warn: ignoring non-existent submodule $m"
+ fi
+done
+
+if test -n "$maybe_modules" && ! test -e ".git"
then
echo "$0: unexpectedly called with submodules but no git checkout exists"
exit 1
@@ -25,14 +53,30 @@ fi
case "$command" in
status)
+ if test -z "$maybe_modules"
+ then
+ test -s ${substat} && exit 1 || exit 0
+ fi
+
test -f "$substat" || exit 1
- trap "rm -f ${substat}.tmp" EXIT
- git submodule status $modules > "${substat}.tmp"
- diff "${substat}" "${substat}.tmp" >/dev/null
+ CURSTATUS=`$GIT submodule status $modules`
+ OLDSTATUS=`cat $substat`
+ test "$CURSTATUS" = "$OLDSTATUS"
exit $?
;;
update)
- git submodule update --init $modules 1>/dev/null
- git submodule status $modules > "${substat}"
+ if test -z "$maybe_modules"
+ then
+ test -e $substat || touch $substat
+ exit 0
+ fi
+
+ $GIT submodule update --init $modules 1>/dev/null
+ test $? -ne 0 && error "failed to update modules"
+
+ $GIT submodule status $modules > "${substat}"
+ test $? -ne 0 && error "failed to save git submodule status" >&2
;;
esac
+
+exit 0